## ros-humble-dynamixel-sdk 3.7.60

=== CMakeLists.txt ===
################################################################################
# Set minimum required version of cmake, project name and compile options
################################################################################
cmake_minimum_required(VERSION 3.5)
project(dynamixel_sdk)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wno-unused-but-set-variable -Wno-unused-parameter -Wno-unused-variable)
endif()

################################################################################
# Find ament packages and libraries for ament and system dependencies
################################################################################
find_package(ament_cmake REQUIRED)

################################################################################
# Build
################################################################################
include_directories(
  include/${PROJECT_NAME}
)

set(DYNAMIXEL_SDK_SOURCES
  src/dynamixel_sdk/packet_handler.cpp
  src/dynamixel_sdk/protocol1_packet_handler.cpp
  src/dynamixel_sdk/protocol2_packet_handler.cpp
  src/dynamixel_sdk/group_sync_read.cpp
  src/dynamixel_sdk/group_sync_write.cpp
  src/dynamixel_sdk/group_bulk_read.cpp
  src/dynamixel_sdk/group_bulk_write.cpp
  src/dynamixel_sdk/port_handler.cpp
)

if(APPLE)
  add_library(dynamixel_sdk SHARED
    ${DYNAMIXEL_SDK_SOURCES}
    src/dynamixel_sdk/port_handler_mac.cpp
  )
elseif(WIN32)
  add_library(dynamixel_sdk SHARED
    ${DYNAMIXEL_SDK_SOURCES}
    src/dynamixel_sdk/port_handler_windows.cpp
  )
else()
  add_library(dynamixel_sdk SHARED
    ${DYNAMIXEL_SDK_SOURCES}
    src/dynamixel_sdk/port_handler_linux.cpp
  )
endif()

################################################################################
# Install
################################################################################
install(
  DIRECTORY include/
  DESTINATION include/
)

install(
  TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

################################################################################
# Macro for ament package
################################################################################
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_package()

=== debian/changelog ===
ros-humble-dynamixel-sdk (3.7.60-1bookworm) bookworm; urgency=high

  * ROS2 Humble Hawksbill supported

 -- Will Son <willson@robotis.com>  Thu, 02 Jun 2022 16:00:00 -0000

ros-humble-dynamixel-sdk (3.7.40-1bookworm) bookworm; urgency=high

  * Add ROS 2 basic example
  * Bug fix
  * Contributors: Will Son

 -- Will Son <willson@robotis.com>  Tue, 13 Apr 2021 16:00:00 -0000

ros-humble-dynamixel-sdk (3.7.30-1bookworm) bookworm; urgency=high

  * ROS 2 Eloquent Elusor supported
  * ROS 2 Foxy Fitzroy supported
  * 3x faster getError member function of GroupSync&BulkRead Class #388
  * Contributors: developer0hye, Zerom, Will Son

 -- Will Son <willson@robotis.com>  Sun, 12 Jul 2020 16:00:00 -0000

ros-humble-dynamixel-sdk (3.7.20-1bookworm) bookworm; urgency=high

  * Fixed buffer overflow bug (rxpacket size)
  * Fixed typo in the package.xml and header files
  * Contributors: Chris Lalancette, Zerom, Pyo

 -- Will Son <willson@robotis.com>  Thu, 05 Sep 2019 16:00:00 -0000

ros-humble-dynamixel-sdk (3.7.10-1bookworm) bookworm; urgency=high

  * Supported ROS 2 Dashing Diademata
  * Contributors: Darby, Pyo

 -- Will Son <willson@robotis.com>  Sun, 18 Aug 2019 16:00:00 -0000

ros-humble-dynamixel-sdk (3.7.0-1bookworm) bookworm; urgency=high

  * Added clear instruction #269 <https://github.com/ROBOTIS-GIT/DynamixelSDK/issues/269>
  * Removed busy waiting for rxPacket()
  * Fixed addStuffing() function (reduced stack memory usage)
  * Fixed memory issues #268 <https://github.com/ROBOTIS-GIT/DynamixelSDK/issues/268>
  * Fixed the broadcast ping bug in dxl_monitor
  * Contributors: Gilbert, Pyo, Zerom

 -- Will Son <willson@robotis.com>  Wed, 02 Jan 2019 16:00:00 -0000

ros-humble-dynamixel-sdk (3.6.2-1bookworm) bookworm; urgency=high

  * Added python modules for ROS to ros folder
  * Moved cpp library files for ROS to ros folder
  * Created an ROS package separately #187 <https://github.com/ROBOTIS-GIT/DynamixelSDK/issues/187>
  * Modified the e-Manual address to emanual.robotis.com
  * Contributors: Pyo

 -- Will Son <willson@robotis.com>  Mon, 16 Jul 2018 16:00:00 -0000

ros-humble-dynamixel-sdk (3.6.1-1bookworm) bookworm; urgency=high

  * removed printTxRxResult(), printRxPacketError() #193 <https://github.com/ROBOTIS-GIT/DynamixelSDK/issues/193>
  * removed cache files
  * merge pull request #195 <https://github.com/ROBOTIS-GIT/DynamixelSDK/issues/195>
  * Contributors: Gilbert, Pyo

 -- Will Son <willson@robotis.com>  Wed, 13 Jun 2018 16:00:00 -0000

ros-humble-dynamixel-sdk (3.6.0-1bookworm) bookworm; urgency=high

  * Replaced : DynamixelSDK Python as a native language (Python 2 and 3 for Windows, Linux, Mac OS X) #93 #122 #147 #181 #182 #185
  * Added : CONTRIBUTING.md added
  * Changes : ISSUE_TEMPLATE.md modified
  * Changes : C++ version - SyncRead / BulkRead - getError functions added
  * Changes : Deprecated functions removed
  * Fixes : DynamixelSDK MATLAB 2017 - new typedef (int8_t / int16_t / int32_t) applied in robotis_def.h #161 #179
  * Fixes : Added missing header file for reset and factory_reset examples #167
  * Contributors: Leon

 -- Will Son <willson@robotis.com>  Thu, 15 Mar 2018 16:00:00 -0000

ros-humble-dynamixel-sdk (3.5.4-1bookworm) bookworm; urgency=high

  * Added : Deprecated is now being shown by attributes #67 #107
  * Fixes : DynamixelSDK ROS Indigo Issue - target_sources func in CMake
  * Fixes : Bug in protocol1_packet_handler.cpp, line 222 checking the returned Error Mask #120
  * Fixes : Packet Handlers - array param uint8_t to uint16_t to avoid closure loop when the packet is too long to be in uint8_t appropriately
  * Fixes : Group Syncwrite using multiple ports in c library issue solved (test code is also in this issue bulletin) #124
  * Fixes : Support getting of time on MacOSX/XCode versions that doesn't support (CLOCK_REALTIME issue) #141 #144
  * Changes : DynamixelSDK Ubuntu Linux usb ftdi latency timer fix issue - changes the default latency timer as 16 ms in all OS, but some about how to change the latency timer was commented in the codes (now the latency timer should be adjusted by yourself... see port_handler_linux source code to see details) #116
  * Contributors: Leon

 -- Will Son <willson@robotis.com>  Thu, 30 Nov 2017 16:00:00 -0000

ros-humble-dynamixel-sdk (3.5.3-1bookworm) bookworm; urgency=high

  * Fixes : DynamixelSDK ROS Kinetic Issue - ARM - Debian Jessie solved by replacing target_sources func in CMake to set_property #136
  * Contributors: Leon

 -- Will Son <willson@robotis.com>  Sun, 29 Oct 2017 16:00:00 -0000

ros-humble-dynamixel-sdk (3.5.2-1bookworm) bookworm; urgency=high

  * Recover : Check if the id of rxpacket is the same as the id of txpacket #82
  * Changes : Ping examples now will not show Dynamixel model number when communication is failed
  * Contributors: Leon

 -- Will Son <willson@robotis.com>  Sun, 17 Sep 2017 16:00:00 -0000

ros-humble-dynamixel-sdk (3.5.1-1bookworm) bookworm; urgency=high

  * Standardizes folder structure of ROS c++
  * Fixes : Inconvenient way of getting meaning of packet result and error value #67
  * Fixes : Maximum length of port name is expanded to 100 #100
  * Alternative : Include port_handler.h through relative path. #90
  * Changes : Indent correction / Example tests & refresh / OS IFDEF
  * Changes : Default Baudrate from 1000000(1M) bps to 57600 bps
  * Changes : Macro for control table value changed to uints
  * Changes : API references will be provided as doxygen (updates in c++ @ 3.5.1)
  * Changes : License changed into Apache License .2.0 (Who are using SDK in previous license can use it as it is)
  * Deprecated : getTxRxResult, getRxPacketError function will be unavailable in Dynamixel SDK 3.6.1
  * Contributors: Leon

 -- Will Son <willson@robotis.com>  Thu, 17 Aug 2017 16:00:00 -0000

ros-humble-dynamixel-sdk (3.4.7-1bookworm) bookworm; urgency=high

  * hotfix - Bug in Dynamixel group control is solved temporarily
  * Contributors: Leon, Zerom



=== debian/control ===
Source: ros-humble-dynamixel-sdk
Section: misc
Priority: optional
Maintainer: Will Son <willson@robotis.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-ros-workspace
Homepage: http://wiki.ros.org/dynamixel_sdk
Standards-Version: 3.9.2

Package: ros-humble-dynamixel-sdk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-ros-workspace
Description: This package is wrapping version of ROBOTIS Dynamixel SDK for ROS 2.
 The ROBOTIS Dynamixel SDK, or SDK, is a software development library that provides Dynamixel control functions for packet communication. The API is designed for Dynamixel actuators and Dynamixel-based platforms.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-dynamixel-sdk//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-dynamixel-sdk//opt/ros/humble/opt/dynamixel_sdk/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
